﻿using System;
using System.Text;
using System.Runtime.InteropServices;

namespace RPGSoundController
{
    static class NativeWin32
    {

        [DllImport("user32.dll")]
        static extern IntPtr PostMessage(IntPtr hWnd, UInt32 Msg, int wParam, int lParam);

        [DllImport("user32.dll")]
        static extern bool SetForegroundWindow(IntPtr hWnd);

        public const UInt32 WM_KEYDOWN = 0x0100;
        public const UInt32 WM_KEYUP = 0x0101;

        public static void SendKey(IntPtr hwnd, byte key, int delay)
        {
            SetForegroundWindow(hwnd);
            System.Threading.Thread.Sleep(delay);
            String keys = "" + (char)key;
            System.Windows.Forms.SendKeys.Send(keys);
            //PostMessage(hwnd, WM_KEYDOWN, (int)key, 0);
            //PostMessage(hwnd, WM_KEYUP, (int)key, 0);
            DoSendKey(key);
        }

        [DllImport("user32.dll", SetLastError = true)]
        static extern IntPtr FindWindow(string lpClassName, string lpWindowName);

        public static IntPtr SearchWindow(String windowName)
        {
            return FindWindow(null, windowName);
        }

        ///////////////////////////////////////////////////////////

        public struct KEYBDINPUT
        {
            public ushort wVk;
            public ushort wScan;
            public uint dwFlags;
            public long time;
            public uint dwExtraInfo;
        };

        [StructLayout(LayoutKind.Explicit, Size = 28)]
        public struct INPUT
        {
            [FieldOffset(0)]
            public uint type;
            [FieldOffset(4)]
            public KEYBDINPUT ki;
        };


        [DllImport("user32.dll")]
        public static extern uint SendInput(uint nInputs, ref INPUT pInputs, int cbSize);

        const int INPUT_KEYBOARD = 1;
        const uint KEYEVENTF_EXTENDEDKEY = 0x0001;
        const uint KEYEVENTF_KEYUP = 0x0002;
        const uint KEYEVENTF_UNICODE = 0x0004;
        const uint KEYEVENTF_SCANCODE = 0x0008;

        [DllImport("user32.dll")]
        static extern void keybd_event(byte bVk, byte bScan, uint dwFlags,
           int dwExtraInfo);

        private static void DoSendKey(byte key)
        {
            /*
            INPUT input = new INPUT();
            input.type = INPUT_KEYBOARD;
            input.ki.wScan = 0x0B;
            input.ki.time = 0;
            input.ki.dwFlags = KEYEVENTF_SCANCODE;
            input.ki.dwExtraInfo = 0;
            input.ki.wVk = 0;
            SendInput(1, ref input, Marshal.SizeOf(input));
            input.ki.dwFlags |= KEYEVENTF_KEYUP;
            SendInput(1, ref input, Marshal.SizeOf(input));
            */
            keybd_event(0x30, 0x0B, 0, 0);
            keybd_event(0x30, 0x0B, KEYEVENTF_KEYUP, 0);
        }

    }
}
